package federe;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

import message.*;

/**<p><code>RTIAFake</code> is not a real RTIA because it doesn't communicate with a RTIG. Its aim is to send back the messages it receives on port number 2000.</p>
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
*/
public class RTIAFake {
	private Socket socket;
	MessageBuffer msgbuff;
	
	public RTIAFake() throws IOException, UnknownHostException{
		this.msgbuff = new MessageBuffer();
		this.socket = new Socket("localhost", 2000); //We open a socket on port number 2000
		System.out.println("Connexion du RTIA sur le port " + this.socket.getLocalPort() + "\n");
		OutputStream out= this.socket.getOutputStream();	
		out.write(5); //We send a byte to federate to say we are ready
	}
	
	private void receptionMessage() throws IOException, InterruptedException{
		//We listen on the socket and we deserialize the message
		InputStream in = this.socket.getInputStream();
		Message msg;
		//this.msgbuff.readSocketNodeserialize(in);
		//System.out.println(this.msgbuff.readAllHex());
		msg = this.msgbuff.deserealize(in);
		//this.msgbuff.reset();
		System.out.println("Reception d'un message :");
		System.out.println(msg.toString());
		Thread.sleep(500);
		//We return the same message that the one we received
		this.attendre();
		this.accuserReception(msg);
	}
	
	private void accuserReception(Message message) throws IOException{
		message.writeObject(this.msgbuff);
		System.out.println("Envoi de l'accuse de reception : " + message.getType()  + "\n");
		this.msgbuff.send(this.socket.getOutputStream());
	}
	
	private void attendre() throws IOException, InterruptedException{
		System.out.println("Appuyer sur Entree pour envoyer l'accuse de reception");
		boolean character = false;
		while (character == false) {
			InputStreamReader instream = new InputStreamReader(System.in);
			BufferedReader inreader = new BufferedReader(instream);
			int c = inreader.read();
			if (c == 13) {
				character = true;
			}
			Thread.sleep(100);
		}
	}
	
	public static final void main(final String[] args) throws IOException , UnknownHostException, InterruptedException{
		System.out.println("Lancement RTIA");
		RTIAFake rtia = new RTIAFake();
		
		while (1==1){
			rtia.receptionMessage();
		}
		
		//rtia.socket.close();
    }
}
