package message;

/**
* <p><code>FederationTime</code> represents the time of the federation associated with the message which is exchanged between the federate and the RTIA.</p>
*
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
*/
public class FederationTime {
	private double fed_time;
	
	/**Creates a new instance of <code>FederationTime</code>. The default initialization set FederationTime to 0.
	 * 
	 */
	public FederationTime(){
		this.fed_time = 0;
	}
	
	/**Creates a new instance of <code>FederationTime</code>.
	 * 
	 * @param fed_time_ the <code>double</code> to set
	 */
	public FederationTime(double fed_time_){
		this.fed_time = fed_time_;
	}

	/**Returns the <code>double</code> fed_time of this <code>FederationTime</code>.
	 * @return the <code>double</code>
	 */
	public double getFed_time() {
		return fed_time;
	}

	/**Sets the <code>double</code> fed_time of this <code>FederationTime</code>.
	 * @param fed_time_ the <code>double</code> to set
	 */
	public void setFed_time(double fed_time_) {
		this.fed_time = fed_time_;
	}
}
