package message;

import message.content.FederationNameFedId;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Create_Federation_Execution extends Message {
	private FederationNameFedId fedNameId;
	
	/**
	 * @return default Create_Federation_Execution message
	 */
	public MSG_Create_Federation_Execution(){
		super(Type.CREATE_FEDERATION_EXECUTION);
		this.fedNameId = new FederationNameFedId("","");
	}
	
	/**
	 * @return Create_Federation_Execution message
	 */
	public MSG_Create_Federation_Execution(Exception exception,
			FederationTime fed_Time, String federationName, String fedId){
		super(Type.CREATE_FEDERATION_EXECUTION, exception, fed_Time);
		this.fedNameId = new FederationNameFedId(federationName, fedId);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>federationName</code>, <code>fedId</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.fedNameId.writeObject(msgBuffer);
	}
	        
	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>federationName</code>, <code>fedId</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.fedNameId.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.fedNameId);
	}

}
