package message;

import message.content.FederationName;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *MSG_
 */
@SuppressWarnings("serial")
public class MSG_Destroy_Federation_Execution extends Message {
	private FederationName federationName;

	/**
	 * @return default Destroy_Federation_Execution message
	 */
	public MSG_Destroy_Federation_Execution() {
		super(Type.DESTROY_FEDERATION_EXECUTION);
		this.federationName = new FederationName("");
	}
		
	/**
	 * @return Destroy_Federation_Execution message
	 */
	public MSG_Destroy_Federation_Execution(Exception exception,
			FederationTime fed_Time, String federationName) {
		super(Type.DESTROY_FEDERATION_EXECUTION, exception, fed_Time);
		this.federationName = new FederationName(federationName);
	}
		
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>federationName</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.federationName.writeObject(msgBuffer);
	}
	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>federationName</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.federationName.readObject(msgBuffer);
	}
	
	public String toString() {
		return (super.toString() + this.federationName);
	}
	
}
