package message;

import message.content.ObjectObjectClass;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Get_Object_Class extends Message {
	private ObjectObjectClass oOClass;
	
	/**
	 * @return default Get_Object_Class message
	 */
	public MSG_Get_Object_Class(){
		super(Type.GET_OBJECT_CLASS);
		this.oOClass = new ObjectObjectClass((long) 0, (long) 0);
	}
	
	/**
	 * @return Get_Object_Class message
	 */
	public MSG_Get_Object_Class(Exception exception, FederationTime fed_Time,
			long obj, long oClass){
		super(Type.GET_OBJECT_CLASS, exception, fed_Time);
		this.oOClass = new ObjectObjectClass(obj, oClass);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>object</code>, <code>objectClass</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.oOClass.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>object</code>, <code>objectClass</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.oOClass.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.oOClass);
	}

}
