package message;

import message.content.ObjectClassNameAttribute;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Get_Object_Class_Name extends Message {
	private ObjectClassNameAttribute oClNameAt;
	
	/**
	 * @return default Get_Object_Class_Name message
	 */
	public MSG_Get_Object_Class_Name(){
		super(Type.GET_OBJECT_CLASS_NAME);
		this.oClNameAt = new ObjectClassNameAttribute((long) 0, "", (short) 0);
	}
	
	/**
	 * @return Get_Object_Class_Name message
	 */
	public MSG_Get_Object_Class_Name(Exception exception,
			FederationTime fed_Time, long oClass,
			String name, short attrib){
		super(Type.GET_OBJECT_CLASS_NAME, exception, fed_Time);
		this.oClNameAt = new ObjectClassNameAttribute(oClass, name, attrib);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>name</code>, <code>attribute</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.oClNameAt.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>name</code>, <code>attribute</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.oClNameAt.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.oClNameAt);
	}

}
