package message;

import message.content.ObjectName;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Get_Object_Instance_Handle extends Message {
	private ObjectName objectName;
	
	/**
	 * @return default Get_Object_Instance_Handle message
	 */
	public MSG_Get_Object_Instance_Handle(){
		super(Type.GET_OBJECT_INSTANCE_HANDLE);
		this.objectName = new ObjectName((long) 0, "");
	}
	
	/**
	 * @return Get_Object_Instance_Handle message
	 */
	public MSG_Get_Object_Instance_Handle(Exception exception,
			FederationTime fed_Time, long obj, String nam){
		super(Type.GET_OBJECT_INSTANCE_HANDLE, exception, fed_Time);
		this.objectName = new ObjectName(obj, nam);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>object</code>, <code>name</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.objectName.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>object</code>, <code>name</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.objectName.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.objectName);
	}

}
