package message;

import message.content.FederateFederationNameFederateName;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Join_Federation_Execution extends Message {
	private FederateFederationNameFederateName fFNFN;
	
	/**
	 * @return default Join_Federation_Execution message
	 */
	public MSG_Join_Federation_Execution() {
		super(Type.JOIN_FEDERATION_EXECUTION);
		this.fFNFN = new FederateFederationNameFederateName((short) 0, "", "");
	}

	/**
	 * @return Join_Federation_Execution message
	 */
	public MSG_Join_Federation_Execution(Exception exception,
			FederationTime fed_Time, short federate,
			String federationName, String federateName) {
		super(Type.JOIN_FEDERATION_EXECUTION, exception, fed_Time);
		this.fFNFN = new FederateFederationNameFederateName(federate,
				federationName, federateName);
	}

	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>federate</code>, <code>federationName</code>, <code>federateName</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.fFNFN.writeObject(msgBuffer);
	}
  	
	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>federate</code>, <code>federationName</code>, <code>federateName</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.fFNFN.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.fFNFN);
	}
  	
}
