package message;

import message.content.ObjectClassHandleArraySizeHandleArray;

/**
 * 
 * @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Publish_Object_class extends Message {
	private ObjectClassHandleArraySizeHandleArray oClassHArSzHAr;
	
	/**
	 * @return default Publish_Object_class message
	 */
	public MSG_Publish_Object_class(){
		super(Type.PUBLISH_OBJECT_CLASS);
		this.oClassHArSzHAr = new ObjectClassHandleArraySizeHandleArray((long) 0, (short) 0, null);
	}
	
	/**
	 * @return Publish_Object_class message
	 */
	public MSG_Publish_Object_class(Exception exception,
			FederationTime fed_Time, long oClass,
			short hArraySize, byte[] hArray){
		super(Type.PUBLISH_OBJECT_CLASS, exception, fed_Time);
		this.oClassHArSzHAr = new ObjectClassHandleArraySizeHandleArray(
				oClass, hArraySize, hArray);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>handleArraySize</code>, <code>handleArray</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.oClassHArSzHAr.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>handleArraySize</code>, <code>handleArray</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.oClassHArSzHAr.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.oClassHArSzHAr);
	}

}
