package message;

import message.content.ObjectClassObjectName;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Register_Object_Instance extends Message {
	private ObjectClassObjectName oClOName;
	
	/**
	 * @return default Register_Object_Instance message
	 */
	public MSG_Register_Object_Instance(){
		super(Type.REGISTER_OBJECT_INSTANCE);
		this.oClOName = new ObjectClassObjectName((long) 0, (long) 0, "");
	}
	
	/**
	 * @return Register_Object_Instance message
	 */
	public MSG_Register_Object_Instance(Exception exception,
			FederationTime fed_time, long oClass, long obj, String name){
		super(Type.REGISTER_OBJECT_INSTANCE, exception, fed_time);
		this.oClOName = new ObjectClassObjectName(oClass, obj, name);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>object</code>, <code>name</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.oClOName.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>object</code>, <code>name</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.oClOName.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.oClOName);
	}

}
