package message;

import message.content.ObjectClassObjectTagNameLabelResignActionBoolean;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Remove_Object_Instance extends Message {
	private ObjectClassObjectTagNameLabelResignActionBoolean oClOTagNameLabRAct;
	
	/**
	 * @return default Remove_Object_Instance message
	 */
	public MSG_Remove_Object_Instance(){
		super(Type.REMOVE_OBJECT_INSTANCE);
		this.oClOTagNameLabRAct = new ObjectClassObjectTagNameLabelResignActionBoolean
				((long) 0, (long) 0, "", "", "", 0, false);
	}
	
	/**
	 * @return Remove_Object_Instance message
	 */
	public MSG_Remove_Object_Instance(Exception exception,
			FederationTime fed_Time, long oClass, long obj,
			String tag, String name, String lab, int resAction , boolean bool){
		super(Type.REMOVE_OBJECT_INSTANCE, exception, fed_Time);
		this.oClOTagNameLabRAct = new ObjectClassObjectTagNameLabelResignActionBoolean(
				oClass, obj, tag, name, lab, resAction , bool);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>object</code>,
	 * <code>tag</code>, <code>name</code>,
	 * <code>label</code>, <code>resignAction</code>, <code>boolean</code>
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.oClOTagNameLabRAct.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>, <code>object</code>,
	 * <code>tag</code>, <code>name</code>,
	 * <code>label</code>, <code>resignAction</code>, <code>boolean</code>
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.oClOTagNameLabRAct.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.oClOTagNameLabRAct);
	}

}
