package message;

import message.content.ResignAction;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Resign_Federation_Execution extends Message {
	private ResignAction resignAction;
	
	/**
	 * @return default Resign_Federation_Execution message
	 */
	public MSG_Resign_Federation_Execution(){
		super(Type.RESIGN_FEDERATION_EXECUTION);
		this.resignAction = new ResignAction(0);
	}
	
	/**
	 * @return Resign_Federation_Execution message
	 */
	public MSG_Resign_Federation_Execution(Exception exception,
			FederationTime fed_time, int resAction){
		super(Type.RESIGN_FEDERATION_EXECUTION, exception, fed_time);
		this.resignAction = new ResignAction(resAction);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>resignAction</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.resignAction.writeObject(msgBuffer);
	}
	
	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>resignAction</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.resignAction.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.resignAction);
	}
	
}
