package message;

import message.content.BooleanTickTimeTickTime;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Tick_Request extends Message {
	private BooleanTickTimeTickTime boolTT;
	
	/**
	 * @return default Tick_Request message
	 */
	public MSG_Tick_Request(){
		super(Type.TICK_REQUEST);
		this.boolTT = new BooleanTickTimeTickTime(false, null, null);
	}
	
	/**
	 * @return Tick_Request message
	 */
	public MSG_Tick_Request(Exception exception, FederationTime fed_time,
			boolean bool, byte[] tickTime1, byte[] tickTime2){
		super(Type.TICK_REQUEST, exception, fed_time);
		this.boolTT = new BooleanTickTimeTickTime(bool, tickTime1, tickTime2);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>boolean</code>,
	 * <code>tickTime</code>,
	 * <code>tickTime</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.boolTT.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>boolean</code>,
	 * <code>tickTime</code>,
	 * <code>tickTime</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		super.readObject(msgBuffer);
		this.boolTT.readObject(msgBuffer);
	}
	
	public String toString(){
		return (super.toString() + this.boolTT);
	}

}
