package message;

import message.content.ObjectClass;

/**
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
@SuppressWarnings("serial")
public class MSG_Unpublish_Object_Class extends Message {
	private ObjectClass objectClass;
	
	/**
	 * @return default Unpublish_Object_Class message
	 */
	public MSG_Unpublish_Object_Class(){
		super(Type.UNPUBLISH_OBJECT_CLASS);
		this.objectClass = new ObjectClass((long) 0);
	}
	
	/**
	 * @return Unpublish_Object_Class message
	 */
	public MSG_Unpublish_Object_Class(Exception exception,
			FederationTime fed_time, long oClass){
		super(Type.UNPUBLISH_OBJECT_CLASS, exception, fed_time);
		this.objectClass = new ObjectClass(oClass);
	}
	
	/**
	 * Writes the message to a buffer:
	 * type of message, exception raised or not, federation time;
	 * <code>objectClass</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		super.writeObject(msgBuffer);
		this.objectClass.writeObject(msgBuffer);
	}

	/**
	 * Reads the message from a buffer:
	 * <code>objectClass</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer) {
		super.writeObject(msgBuffer);
		this.objectClass.readObject(msgBuffer);
	}
	
	public String toString() {
		return (super.toString() + this.objectClass);
	}

}
