package message.content;

import message.MessageBuffer;

/**
 * Treatment of messages containing <code>federationName</code>:
 * namely <code>MSG_Destroy_Federation_Execution</code>.
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
public class FederationName {
	private String federationName;

	public FederationName(String federationName) {
		this.federationName = federationName;
	}

	/**
	 * Writes the message to a buffer:
	 * <code>federationName</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		msgBuffer.write(this.federationName, "federationName");
	}

	/**
	 * Reads the message from a buffer:
	 * <code>federationName</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		this.federationName = msgBuffer.readString();
	}

	/**
	 * @param federationName the federationName to set
	 */
	public void setFederationName(String federationName) {
		this.federationName = federationName;
	}

	/**
	 * @return the federationName
	 */
	public String getFederationName() {
		return federationName;
	}

}
