package message.content;

import message.MessageBuffer;

/**
 * Treatment of messages containing <code>resignAction</code>:
 * namely <code>MSG_Resign_Federation_Execution</code>.
 * 
* @author <a href = "mailto:yannick.bisiaux@supaero.fr">Yannick Bisiaux</a>, <a href = "mailto:ronan.bossard@supaero.fr">Ronan Bossard</a>, <a href = "mailto:samuel.reese@supaero.fr">Samuel Reese</a>
* @version 1.0
 *
 */
public class ResignAction {
	private int resignAction;

	public ResignAction (int resAction) {
		this.resignAction = resAction;
	}

	/**
	 * Writes the message to a buffer:
	 * <code>resignAction</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * to which the message is written.
	 */
	public void writeObject(MessageBuffer msgBuffer){
		msgBuffer.write(this.resignAction, "resignAction");
	}

	/**
	 * Reads the message from a buffer:
	 * <code>resignAction</code>.
	 * 
	 * @param msgBuffer the <code>MessageBuffer</code>
	 * from which the message is read.
	 */
	public void readObject(MessageBuffer msgBuffer){
		this.resignAction = msgBuffer.readInt();
	}

	/**
	 * @param resignAction the resignAction to set
	 */
	public void setResignAction(int resignAction) {
		this.resignAction = resignAction;
	}

	/**
	 * @return the resignAction
	 */
	public int getResignAction() {
		return resignAction;
	}

}
